{% extends "base.html" %}
{% block static %}
  {% load static %}
  <link rel="stylesheet" type="text/css" href="{% static 'style/app.css' %}">
{% endblock %}
{% block title %}App log{% endblock %}
{% block content %}
  <div id="app-log-page" class="outer-div">
    <div class="mx-auto">
      <h1 id="app-heading"></h1>
      <p>Status: <strong>{{ status }}</strong></p>

      {% if status == 200 %}
            <!-- Container navbar -->
        <ul class="nav nav-tabs" id="myTab" role="tablist">
          {% for container in application.container_set.all %}
            <li class="nav-item" role="presentation">
              <button class="nav-link {% if forloop.first %}active{% endif %}" data-bs-toggle="tab" data-bs-target="#container-{{ forloop.counter0 }}-log-tab-pane" type="button" role="tab" aria-controls="container-{{ forloop.counter0 }}-log-tab-pane" aria-selected="true">{{ container }}</button>
            </li>
          {% endfor %}
        </ul>

            <!-- Container log tab -->
        <div class="tab-content app-display" id="myTabContent">
          {% for container in application.container_set.all %}
            <div class="tab-pane fade {% if forloop.first %}show active{% endif %}" id="container-{{ forloop.counter0 }}-log-tab-pane" role="tabpanel" aria-labelledby="container-{{ forloop.counter0 }}-log-tab-pane" tabindex="0">
              <div class="bg-dark text-white p-5">
                        <pre class="container-log" id="container-{{ forloop.counter0 }}-log" data-container-index="{{ forloop.counter0 }}">{{ log |safe }}</pre>
              </div>
            </div>
          {% endfor %}
        </div>
      {% else %}
        <h5>{{ log }}</h5>
      {% endif %}
    </div>
  </div>
  {% if status == 200 %}
    <script>
      console.log("Connect to app log web socket")
        // Get app id from the current URL
      const appId = window.location.href.split('/').at(-2);

      $('#app-heading').text(`App log for ${appId}`);

        // Connect with the consumer in Django
      var ws_scheme = window.location.protocol == "https:" ? "wss" : "ws";

      const containerLogs = document.querySelectorAll('.container-log');
      containerLogs.forEach(containerLog => {
        const containerIndex = containerLog.dataset.containerIndex;
        const containerLogSocket = new WebSocket(
          `${ws_scheme}://${window.location.host}/ws/app_log/${appId}/${containerIndex}`
        );

            // Receive and render a new ouput everytime there is a change in the log file
        containerLogSocket.onmessage = e => {
          const data = JSON.parse(e.data);
          containerLog.innerHTML += (data.content + '<br/>');
        };

            // Return an error if the socket is closed unexpectedly
        containerLogSocket.onclose = e => {
          console.error('Deploy socket is closed');
        };

            // Closing the WebSocket before closing the browser
        window.onbeforeunload = () => {
          containerLogSocket.close();
        }
      });
    </script>
  {% endif %}
{% endblock %}